﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using MindFusion.Charting.Wpf;
using System.Windows.Media.Media3D;

namespace BarChart3D
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        //private List<DoubleCollection> dataList;
        //private List<DoubleCollection> positionList;
        //private List<BarSeries> seriesList;
        private Random r = new Random();
        private List<Brush> brushesList;
        private bool unlock;

        public Window1()
        {
            InitializeComponent();



            Background = new LinearGradientBrush(Colors.SteelBlue, Colors.White, 0);
            //barChart3D.RenderBackSides = true;
            barChart3D.Series.Clear();

            //Initialize data		
            brushesList = new List<Brush>();
            byte t = 200;
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.DodgerBlue.Color.R, Brushes.DodgerBlue.Color.G, Brushes.DodgerBlue.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.Brown.Color.R, Brushes.Brown.Color.G, Brushes.Brown.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.Orange.Color.R, Brushes.Orange.Color.G, Brushes.Orange.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.Yellow.Color.R, Brushes.Yellow.Color.G, Brushes.Yellow.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.Green.Color.R, Brushes.Green.Color.G, Brushes.Green.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.Azure.Color.R, Brushes.Azure.Color.G, Brushes.Azure.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.LightSteelBlue.Color.R, Brushes.LightSteelBlue.Color.G, Brushes.LightSteelBlue.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.SteelBlue.Color.R, Brushes.SteelBlue.Color.G, Brushes.SteelBlue.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.DarkBlue.Color.R, Brushes.DarkBlue.Color.G, Brushes.DarkBlue.Color.B)));
            brushesList.Add(new SolidColorBrush(Color.FromArgb(t,
                Brushes.DarkViolet.Color.R, Brushes.DarkViolet.Color.G, Brushes.DarkViolet.Color.B)));

            //dataList = new List<DoubleCollection>();
            //positionList = new List<DoubleCollection>();
            //seriesList = new List<BarSeries>();

           

            AddSeries();
            unlock = true;

            barType3D.SelectedIndex = 0;

            barChart3D.YAxisSettings.Interval = 10;
            barChart3D.XAxisSettings.Interval = 1;



            barChart3D.XAxisSettings.LabelFontSize = 11;
            barChart3D.XAxisSettings.LabelOffset = 3;
            barChart3D.XAxisSettings.LabelFormat = "0.##";
            barChart3D.XAxisSettings.TitleFontSize = 12;
            barChart3D.XAxisSettings.TitleOffset = 5;
            barChart3D.XAxisSettings.Tick = 0.5;
            barChart3D.XAxisSettings.Title = "Month";

            barChart3D.YAxisSettings.LabelFontSize = 11;
            barChart3D.YAxisSettings.LabelOffset = 3;
            barChart3D.YAxisSettings.LabelFormat = "0.##";
            barChart3D.YAxisSettings.TitleFontSize = 12;
            barChart3D.YAxisSettings.TitleOffset = 5;
            barChart3D.YAxisSettings.Tick = 0.5;
            //barChart3D.YAxisSettings.TitleRotationAngle = 270;
            barChart3D.YAxisSettings.Title = "Sales";

            barChart3D.SideWallThickness = 0.5;
            //DirectionalLight light = new DirectionalLight()
            //{
            //    Color = Colors.White,
            //    Direction = new Vector3D(-1, 3, -1),
            //};
            //barChart3D.StaticLights.Add(light);
            barChart3D.MouseDown += new MouseButtonEventHandler(barChart3D_MouseDown);
           
        }

        void barChart3D_MouseDown(object sender, MouseButtonEventArgs e)
        {
            //if (hitCheck.IsChecked == true)
            //{
            //    ChartHitTestResult3D result = surfaceChart.HitTest(e.GetPosition(this));
            //    Point3D realPoint = result.MeshPoint;
            //    Point3D dataPoint = result.DataPoint;
            //    Point3D peak = result.ClosestPeak;

            //    string sx = realPoint.X.ToString("0.##");
            //    string sy = realPoint.Y.ToString("0.##");
            //    string sz = realPoint.Z.ToString("0.##");
            //    string realPointString = "- Mesh Point: X=" + sx + ", Y=" + sy + ", Z=" + sz;

            //    sx = dataPoint.X.ToString("0.##");
            //    sy = dataPoint.Y.ToString("0.##");
            //    sz = dataPoint.Z.ToString("0.##");
            //    string dataPointString = "- Data Point: X=" + sx + ", Y=" + sy + ", Z=" + sz;

            //    sx = peak.X.ToString("0.##");
            //    sy = peak.Y.ToString("0.##");
            //    sz = peak.Z.ToString("0.##");
            //    string peakString = "- Closest Peak: X=" + sx + ", Y=" + sy + ", Z=" + sz;

            //    string seriesIndex = "- Series Index:" + surfaceChart.Series.IndexOf(result.Series).ToString();


            //    string title = "HitTest Result:";
            //    listView1.Items.Add(title);
            //    listView1.Items.Add(realPointString);
            //    listView1.Items.Add(dataPointString);
            //    listView1.Items.Add(peakString);
            //    listView1.Items.Add(seriesIndex);
            //}
        }

        private void AddSeries()
        {
            DoubleCollection d1 = new DoubleCollection(){
                  r.Next(95) + 5, r.Next(95) + 5, r.Next(95) + 5, r.Next(95) + 5 };
            DoubleCollection d2 = new DoubleCollection() { 1, 2, 3, 4 };
             


            int index = barChart3D.Series.Count % brushesList.Count;

            BarSeries series = new BarSeries();
            series.Fills.Add(brushesList[index]);
            series.BarWidth = barWidthValue.Value;
            if (!IsVertical)
            {
                series.XData = d1;
                series.YData = d2;
            }
            else
            {
                series.XData = d2;
                series.YData = d1;
            }
            barChart3D.Series.Add(series);          
        }

        private void RemoveSeries()
        {
            if (barChart3D.Series.Count > 0)
            {
                int i = barChart3D.Series.Count - 1;            
                barChart3D.Series.Remove(barChart3D.Series[i]);               
            }
        }

        private bool IsVertical
        {
            get
            {
                if (barChart3D.BarType3D == BarType3D.Vertical ||
                    barChart3D.BarType3D == BarType3D.VerticalInColumn ||
                    barChart3D.BarType3D == BarType3D.VerticalStack)
                {
                    return true;
                }
                else
                    return false;
            }
        }

        private void Update()
        {
            if (!unlock)
                return;

            barChart3D.BeginInit();

            bool switchData = false;
            int index = barType3D.SelectedIndex;
            if (index < 3 && !IsVertical)
                switchData = true;
            else if (index >= 3 && IsVertical)
                switchData = true;
            if (switchData)
            {
                double t1 = barChart3D.XAxisSettings.Interval;
                double t2 = barChart3D.YAxisSettings.Interval;
                string s1 = barChart3D.XAxisSettings.Title;
                string s2 = barChart3D.YAxisSettings.Title;
                barChart3D.XAxisSettings.Interval = t2;
                barChart3D.YAxisSettings.Interval = t1;
                barChart3D.XAxisSettings.Title = s2;
                barChart3D.YAxisSettings.Title = s1;

                foreach (BarSeries series in barChart3D.Series)               
                {
                    DoubleCollection d1 = series.XData.Clone();
                    DoubleCollection d2 = series.YData.Clone();                   
                    series.XData = d2;
                    series.YData = d1;                  
                }
            }
            

            if (barType3D.SelectedIndex == 0)
                barChart3D.BarType3D = BarType3D.Vertical;
            else if (barType3D.SelectedIndex == 1)
                barChart3D.BarType3D = BarType3D.VerticalInColumn;
            else if (barType3D.SelectedIndex == 2)
                barChart3D.BarType3D = BarType3D.VerticalStack;
            else if (barType3D.SelectedIndex == 3)
                barChart3D.BarType3D = BarType3D.Horizontal;
            else if (barType3D.SelectedIndex == 4)
                barChart3D.BarType3D = BarType3D.HorizontalInColumn;
            else if (barType3D.SelectedIndex == 5)
                barChart3D.BarType3D = BarType3D.HorizontalStack;

            barChart3D.SeriesWidth = seriesWidthValue.Value;
            barChart3D.ModelWidth = modelWidthValue.Value;
            barChart3D.ModelHeight = modelHeightValue.Value;
            barChart3D.ModelDepth = modelDepthValue.Value;
            barChart3D.CornerRadius3D = cornerRadius3DValue.Value;
            if (roundCornerType.SelectedIndex == 0)
                barChart3D.RoundCornerType = RoundCornerType.Top;
            else if (roundCornerType.SelectedIndex == 1)
                barChart3D.RoundCornerType = RoundCornerType.Bottom;
            else if (roundCornerType.SelectedIndex == 2)
                barChart3D.RoundCornerType = RoundCornerType.All;
            else if (roundCornerType.SelectedIndex == 3)
                barChart3D.RoundCornerType = RoundCornerType.None;
            barChart3D.EndInit();
        }

        private void barValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            barChart3D.BeginInit();
            for (int i = 0; i < barChart3D.Series.Count; i++)
            {
                if (barChart3D.BarType3D == BarType3D.Vertical ||
                    barChart3D.BarType3D == BarType3D.VerticalInColumn ||
                    barChart3D.BarType3D == BarType3D.VerticalStack)
                {
                    //(barChart3D.Series[i] as BarSeries).YData[barSelection.SelectedIndex] = barValue.Value;
                }
                else
                {
                    //(barChart3D.Series[i] as BarSeries).XData[barSelection.SelectedIndex] = barValue.Value;
                }
            }
            barChart3D.EndInit();
        }

        private void barType3D_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Update();
        }

        private void barSelection_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            AddSeries();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            RemoveSeries();
        }

        private void seriesWidthValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //Update();
            barChart3D.SeriesWidth = seriesWidthValue.Value;
        }

        private void barWidthValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //Update();
            barChart3D.BeginInit();
            foreach (BarSeries series in barChart3D.Series)
                series.BarWidth = barWidthValue.Value;
            barChart3D.EndInit();
        }

        private void modelWidthValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //Update();
            barChart3D.ModelWidth = modelWidthValue.Value;            
        }

        private void modelHeightValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
           // Update();            
            barChart3D.ModelHeight = modelHeightValue.Value;            
        }

        private void modelDepthValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //Update();           
            barChart3D.ModelDepth = modelDepthValue.Value;
        }

        private void cornerRadius3DValue_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            //Update();
            barChart3D.CornerRadius3D = cornerRadius3DValue.Value;
        }

        private void cornerRadiusType_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Update();
        }

        private void behavior_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if ((sender as ComboBox).SelectedIndex == 0)
                barChart3D.Behavior = Behavior3D.ChangePerspective;
            else
                barChart3D.Behavior = Behavior3D.ChangeValue;
        }	
    }
}
